/*******************************************************************                                                                
*   SASload_KID_1997_CORE.SAS:                                                                                                      
*      THE SAS CODE SHOWN BELOW WILL LOAD THE ASCII                                                                                 
*      INPATIENT STAY CORE FILE INTO SAS                                                                                            
*******************************************************************/                                                                
                                                                                                                                    
                                                                                                                                    
***********************************************;                                                                                    
*  Create SAS informats for missing values     ;                                                                                    
***********************************************;                                                                                    
PROC FORMAT;                                                                                                                        
  INVALUE N2PF                                                                                                                      
    '-9' = .                                                                                                                        
    '-8' = .A                                                                                                                       
    '-6' = .C                                                                                                                       
    '-5' = .N                                                                                                                       
    OTHER = (|2.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N3PF                                                                                                                      
    '-99' = .                                                                                                                       
    '-88' = .A                                                                                                                      
    '-66' = .C                                                                                                                      
    OTHER = (|3.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N4PF                                                                                                                      
    '-999' = .                                                                                                                      
    '-888' = .A                                                                                                                     
    '-666' = .C                                                                                                                     
    OTHER = (|4.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N5PF                                                                                                                      
    '-9999' = .                                                                                                                     
    '-8888' = .A                                                                                                                    
    '-6666' = .C                                                                                                                    
    OTHER = (|5.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N6PF                                                                                                                      
    '-99999' = .                                                                                                                    
    '-88888' = .A                                                                                                                   
    '-66666' = .C                                                                                                                   
    OTHER = (|6.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N6P2F                                                                                                                     
    '-99.99' = .                                                                                                                    
    '-88.88' = .A                                                                                                                   
    '-66.66' = .C                                                                                                                   
    OTHER = (|6.2|)                                                                                                                 
  ;                                                                                                                                 
  INVALUE N7P2F                                                                                                                     
    '-999.99' = .                                                                                                                   
    '-888.88' = .A                                                                                                                  
    '-666.66' = .C                                                                                                                  
    OTHER = (|7.2|)                                                                                                                 
  ;                                                                                                                                 
  INVALUE N8PF                                                                                                                      
    '-9999999' = .                                                                                                                  
    '-8888888' = .A                                                                                                                 
    '-6666666' = .C                                                                                                                 
    OTHER = (|8.|)                                                                                                                  
  ;                                                                                                                                 
  INVALUE N8P2F                                                                                                                     
    '-9999.99' = .                                                                                                                  
    '-8888.88' = .A                                                                                                                 
    '-6666.66' = .C                                                                                                                 
    OTHER = (|8.2|)                                                                                                                 
  ;                                                                                                                                 
  INVALUE N8P4F                                                                                                                     
    '-99.9999' = .                                                                                                                  
    '-88.8888' = .A                                                                                                                 
    '-66.6666' = .C                                                                                                                 
    OTHER = (|8.4|)                                                                                                                 
  ;                                                                                                                                 
  INVALUE N10PF                                                                                                                     
    '-999999999' = .                                                                                                                
    '-888888888' = .A                                                                                                               
    '-666666666' = .C                                                                                                               
    OTHER = (|10.|)                                                                                                                 
  ;                                                                                                                                 
  INVALUE N10P4F                                                                                                                    
    '-9999.9999' = .                                                                                                                
    '-8888.8888' = .A                                                                                                               
    '-6666.6666' = .C                                                                                                               
    OTHER = (|10.4|)                                                                                                                
  ;                                                                                                                                 
  INVALUE DATE10F                                                                                                                   
    '-999999999' = .                                                                                                                
    '-888888888' = .A                                                                                                               
    '-666666666' = .C                                                                                                               
    OTHER = (|MMDDYY10.|)                                                                                                           
  ;                                                                                                                                 
  INVALUE N12P2F                                                                                                                    
    '-99999999.99' = .                                                                                                              
    '-88888888.88' = .A                                                                                                             
    '-66666666.66' = .C                                                                                                             
    OTHER = (|12.2|)                                                                                                                
  ;                                                                                                                                 
  INVALUE N15P2F                                                                                                                    
    '-99999999999.99' = .                                                                                                           
    '-88888888888.88' = .A                                                                                                          
    '-66666666666.66' = .C                                                                                                          
    OTHER = (|15.2|)                                                                                                                
  ;                                                                                                                                 
  RUN;                                                                                                                              
                                                                                                                                    
                                                                                                                                    
*******************************;                                                                                                    
*  Data Step                  *;                                                                                                    
*******************************;                                                                                                
DATA KID_1997_CORE; 
INFILE EBCORE LRECL = 347; 

LENGTH 
       HOSPNUM  4
       RECNUM   5
       ADAYWK   3
       AGE      3
       AGEDAY   3
       AGEMONTH 3
       AMONTH   3
       ASOURCE  3
       ATYPE    3
       DCCHPR1  3
       DIED     3
       DISCWT_U 8
       DISP     3
       DQTR     3
       DRG      3
       DRG10    3
       DX1      $5
       DX2      $5
       DX3      $5
       DX4      $5
       DX5      $5
       DX6      $5
       DX7      $5
       DX8      $5
       DX9      $5
       DX10     $5
       DX11     $5
       DX12     $5
       DX13     $5
       DX14     $5
       DX15     $5
       DXV1     3
       DXV2     3
       DXV3     3
       DXV4     3
       DXV5     3
       DXV6     3
       DXV7     3
       DXV8     3
       DXV9     3
       DXV10    3
       DXV11    3
       DXV12    3
       DXV13    3
       DXV14    3
       DXV15    3
       HOSPBRTH 3
       LOS      4
       LOS_X    4
       MDC      3
       MDID_S   $16
       NDX      3
       NEOMAT   3
       NPR      3
       PAY1     3
       PAY2     3
       PAY1_N   3
       PAY2_N   3
       PCCHPR1  3
       PR1      $4
       PR2      $4
       PR3      $4
       PR4      $4
       PR5      $4
       PR6      $4
       PR7      $4
       PR8      $4
       PR9      $4
       PR10     $4
       PR11     $4
       PR12     $4
       PR13     $4
       PR14     $4
       PR15     $4
       PRDAY1   4
       PRV1     3
       PRV2     3
       PRV3     3
       PRV4     3
       PRV5     3
       PRV6     3
       PRV7     3
       PRV8     3
       PRV9     3
       PRV10    3
       PRV11    3
       PRV12    3
       PRV13    3
       PRV14    3
       PRV15    3
       RACE     3
       SEX      3
       SURGID_S $16
       TOTCHG   6
       TOTCHG_X 7
       UNCBRTH  3
       ZIPINC4  3
;

LABEL 
      HOSPNUM ="Synthetic hospital number"
      RECNUM  ="Sequential record number"
      ADAYWK  ="I:Admission day of week"
      AGE     ="I:Age in years at admission"
      AGEDAY  ="I:Age in days (when < 1 year)"
      AGEMONTH="I:Age in months (when < 11 years)"
      AMONTH  ="I:Admission month"
      ASOURCE ="I:Admission source"
      ATYPE   ="I:Admission type"
      DCCHPR1 ="I:CCHPR: principal diagnosis"
      DIED    ="I:Died during hospitalization"
      DISCWT_U="I:Weight to discharges in universe"
      DISP    ="I:Disposition of patient"
      DQTR    ="I:Discharge quarter"
      DRG     ="I:DRG in effect on discharge date"
      DRG10   ="I:DRG, Version 10"
      DX1     ="I:Principal diagnosis"
      DX2     ="I:Diagnosis 2"
      DX3     ="I:Diagnosis 3"
      DX4     ="I:Diagnosis 4"
      DX5     ="I:Diagnosis 5"
      DX6     ="I:Diagnosis 6"
      DX7     ="I:Diagnosis 7"
      DX8     ="I:Diagnosis 8"
      DX9     ="I:Diagnosis 9"
      DX10    ="I:Diagnosis 10"
      DX11    ="I:Diagnosis 11"
      DX12    ="I:Diagnosis 12"
      DX13    ="I:Diagnosis 13"
      DX14    ="I:Diagnosis 14"
      DX15    ="I:Diagnosis 15"
      DXV1    ="I:Validity flag: principal diagnosis"
      DXV2    ="I:Validity flag: diagnosis 2"
      DXV3    ="I:Validity flag: diagnosis 3"
      DXV4    ="I:Validity flag: diagnosis 4"
      DXV5    ="I:Validity flag: diagnosis 5"
      DXV6    ="I:Validity flag: diagnosis 6"
      DXV7    ="I:Validity flag: diagnosis 7"
      DXV8    ="I:Validity flag: diagnosis 8"
      DXV9    ="I:Validity flag: diagnosis 9"
      DXV10   ="I:Validity flag: diagnosis 10"
      DXV11   ="I:Validity flag: diagnosis 11"
      DXV12   ="I:Validity flag: diagnosis 12"
      DXV13   ="I:Validity flag: diagnosis 13"
      DXV14   ="I:Validity flag: diagnosis 14"
      DXV15   ="I:Validity flag: diagnosis 15"
      HOSPBRTH="I:Birth DX, in this hospital"
      LOS     ="I:Length of stay (cleaned)"
      LOS_X   ="I:Length of stay (uncleaned)"
      MDC     ="I:MDC in effect on discharge date"
      MDID_S  ="I:Attending physician number (synthetic)"
      NDX     ="I:Number of diagnoses on this discharge"
      NEOMAT  ="I:Neonatal and/or maternal DX and/or PR"
      NPR     ="I:Number of procedures on this discharge"
      PAY1    ="I:Primary expected payer, uniform"
      PAY2    ="I:Secondary expected payer, uniform"
      PAY1_N  ="I:Primary expected payer, nonuniform"
      PAY2_N  ="I:Secondary expected payer, nonuniform"
      PCCHPR1 ="I:CCHPR: principal procedure"
      PR1     ="I:Principal procedure"
      PR2     ="I:Procedure 2"
      PR3     ="I:Procedure 3"
      PR4     ="I:Procedure 4"
      PR5     ="I:Procedure 5"
      PR6     ="I:Procedure 6"
      PR7     ="I:Procedure 7"
      PR8     ="I:Procedure 8"
      PR9     ="I:Procedure 9"
      PR10    ="I:Procedure 10"
      PR11    ="I:Procedure 11"
      PR12    ="I:Procedure 12"
      PR13    ="I:Procedure 13"
      PR14    ="I:Procedure 14"
      PR15    ="I:Procedure 15"
      PRDAY1  ="I:No. of days from admission to PR1"
      PRV1    ="I:Validity flag: principal procedure"
      PRV2    ="I:Validity flag: procedure 2"
      PRV3    ="I:Validity flag: procedure 3"
      PRV4    ="I:Validity flag: procedure 4"
      PRV5    ="I:Validity flag: procedure 5"
      PRV6    ="I:Validity flag: procedure 6"
      PRV7    ="I:Validity flag: procedure 7"
      PRV8    ="I:Validity flag: procedure 8"
      PRV9    ="I:Validity flag: procedure 9"
      PRV10   ="I:Validity flag: procedure 10"
      PRV11   ="I:Validity flag: procedure 11"
      PRV12   ="I:Validity flag: procedure 12"
      PRV13   ="I:Validity flag: procedure 13"
      PRV14   ="I:Validity flag: procedure 14"
      PRV15   ="I:Validity flag: procedure 15"
      RACE    ="I:Race"
      SEX     ="I:Sex"
      SURGID_S="I:Primary surgeon number (synthetic)"
      TOTCHG  ="I:Total charges (cleaned)"
      TOTCHG_X="I:Total charges (from data source)"
      UNCBRTH ="I:Normal uncomplicated birth in hospital"
      ZIPINC4 ="I:Median income-pt's zip code-4 categs"
;

*** Input the variables from the ASCII file ***;                                                                                    
INPUT 
      @1      HOSPNUM   5.
      @6      RECNUM    7.
      @13     ADAYWK    N2PF.
      @15     AGE       N3PF.
      @18     AGEDAY    N3PF.
      @21     AGEMONTH  N3PF.
      @24     AMONTH    N2PF.
      @26     ASOURCE   N2PF.
      @28     ATYPE     N2PF.
      @30     DCCHPR1   N3PF.
      @33     DIED      N2PF.
      @35     DISCWT_U  10.5
      @45     DISP      N2PF.
      @47     DQTR      1.
      @48     DRG       N3PF.
      @51     DRG10     N3PF.
      @54     DX1       $CHAR5.
      @59     DX2       $CHAR5.
      @64     DX3       $CHAR5.
      @69     DX4       $CHAR5.
      @74     DX5       $CHAR5.
      @79     DX6       $CHAR5.
      @84     DX7       $CHAR5.
      @89     DX8       $CHAR5.
      @94     DX9       $CHAR5.
      @99     DX10      $CHAR5.
      @104    DX11      $CHAR5.
      @109    DX12      $CHAR5.
      @114    DX13      $CHAR5.
      @119    DX14      $CHAR5.
      @124    DX15      $CHAR5.
      @129    DXV1      N2PF.
      @131    DXV2      N2PF.
      @133    DXV3      N2PF.
      @135    DXV4      N2PF.
      @137    DXV5      N2PF.
      @139    DXV6      N2PF.
      @141    DXV7      N2PF.
      @143    DXV8      N2PF.
      @145    DXV9      N2PF.
      @147    DXV10     N2PF.
      @149    DXV11     N2PF.
      @151    DXV12     N2PF.
      @153    DXV13     N2PF.
      @155    DXV14     N2PF.
      @157    DXV15     N2PF.
      @159    HOSPBRTH  1.
      @160    LOS       N5PF.
      @165    LOS_X     N6PF.
      @171    MDC       N2PF.
      @173    MDID_S    $CHAR16.
      @189    NDX       N2PF.
      @191    NEOMAT    1.
      @192    NPR       N2PF.
      @194    PAY1      N2PF.
      @196    PAY2      N2PF.
      @198    PAY1_N    N2PF.
      @200    PAY2_N    N2PF.
      @202    PCCHPR1   N3PF.
      @205    PR1       $CHAR4.
      @209    PR2       $CHAR4.
      @213    PR3       $CHAR4.
      @217    PR4       $CHAR4.
      @221    PR5       $CHAR4.
      @225    PR6       $CHAR4.
      @229    PR7       $CHAR4.
      @233    PR8       $CHAR4.
      @237    PR9       $CHAR4.
      @241    PR10      $CHAR4.
      @245    PR11      $CHAR4.
      @249    PR12      $CHAR4.
      @253    PR13      $CHAR4.
      @257    PR14      $CHAR4.
      @261    PR15      $CHAR4.
      @265    PRDAY1    N5PF.
      @270    PRV1      N2PF.
      @272    PRV2      N2PF.
      @274    PRV3      N2PF.
      @276    PRV4      N2PF.
      @278    PRV5      N2PF.
      @280    PRV6      N2PF.
      @282    PRV7      N2PF.
      @284    PRV8      N2PF.
      @286    PRV9      N2PF.
      @288    PRV10     N2PF.
      @290    PRV11     N2PF.
      @292    PRV12     N2PF.
      @294    PRV13     N2PF.
      @296    PRV14     N2PF.
      @298    PRV15     N2PF.
      @300    RACE      N2PF.
      @302    SEX       N2PF.
      @304    SURGID_S  $CHAR16.
      @320    TOTCHG    N10PF.
      @330    TOTCHG_X  N15P2F.
      @345    UNCBRTH   1.
      @346    ZIPINC4   N2PF.
;

RUN;



